<template>
    <!-- chat -->
    <div class="chat">
        <div v-if="contact"  class="chat-header">
            <div class="chat-header-user">
                <figure class="avatar avatar-lg">
                    <img :src="'assets/chat/dist/media/img/1.jpg'" class="rounded-circle">
                </figure>
                <div v-if="contact">
                    <h5>{{contact.name}}</h5>
                    <small class="text-muted">
                        <i>Online</i>
                    </small>
                </div>
            </div>
            <div class="chat-header-action">
                <ul class="list-inline">
                    <li class="list-inline-item">
                        <a  @click="call()" class="btn btn-success">
                            <i class="fa fa-phone" aria-hidden="true"></i>
                        </a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" class="btn btn-secondary">
                            <i class="fa fa-video-camera" aria-hidden="true"></i>
                        </a>
                    </li>
                </ul>
            </div>
        </div>
        <div class="chat-body" :class="contact?'':'no-message'">
            <div v-if="!contact" class="no-message-container">
                <span><i class="fas fa-comments-o"></i></span>
                <p>Select a chat to read messages</p>
            </div>
            <div v-if="contact" class="messages feed" ref="feed">
                <div v-for="message in messages" :key="message.id" :class="message.to === contact.id?'':'outgoing-message'" class="message-item">
                    <div class="message-content">
                        {{ message.message }}
                    </div>
                    <div class="message-action">
                        {{message.created_at}}
                    </div>
                </div>
            </div>
        </div>
        <ComposeMessage v-if="contact" @send="sendMessage"/>
    </div>
    <!-- ./ chat -->
</template>
<script>
    import ComposeMessage from './ComposeMessage';
    export default {
        props:{
            messages:{
                type:Array,
                required: true
            },
            contact: {
                type: Object
            },
        },
        methods:{
            sendMessage(text){
                if (!this.contact) return;
                axios.post('/sent/message',{
                    contact_id: this.contact.id,
                    message: text
                }).then((response)=>{
                   this.$emit('new',response.data);
                });
            },
            scrollToBottom(){
                setTimeout(()=>{
                    this.$refs.messages.scrollTop = this.$refs.messages.scrollHeight - this.$refs.messages.clientHeight;
                },50);
            }
        },
        watch:{
            contact(contact){
                this.scrollToBottom();
            },
            message(message){
                this.scrollToBottom();
            }
        },
        call(){
            alert('working');
            document.getElementById('call').modal('show');
        },
        components: {ComposeMessage}
    }
</script>
